#!/usr/bin/env python
#--------------------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2008
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program License Agreement.
# See the software licensing materials that came with the IBM XIV Storage System for terms and conditions.
#
#--------------------------------------------------------------------------------------------------------------

from re import search
from commands import getoutput
from sys import exit
import logging

VERSION = "1.0.1"
PACKAGE_DIR = '/opt/xiv/host_attach'
LOGFILE_PATH = PACKAGE_DIR + '/var/log/host_attach'


def is_error_free (text):
	if text.__contains__('command not found'):
		return 0
	elif text.__contains__('No such file'):
		return 0
	elif text.__contains__('error') or text.__contains__('failed'):
	   return 0
  	elif text.__contains__('ERROR') or text.__contains__('FAILED'):
	   return 0
	return 1

def is_this_ip_address(ip_address):
	pattern = '^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$'
	address = search(pattern, ip_address)
	match_found = 0
	try:
		address.group()
	except AttributeError:
		return 0
	return 1

def get_logger():
	logger = logging.Logger('host_attach')
	console_handler = logging.StreamHandler()
	console_handler.setLevel(logging.INFO)
	console_formatter = logging.Formatter('%(levelname)s: %(message)s')
	console_handler.formatter = console_formatter
	logger.addHandler(console_handler)
	logfile_handler = logging.FileHandler(LOGFILE_PATH, 'a')
	logfile_handler.setLevel(logging.DEBUG)
	logfile_formatter = logging.Formatter('%(asctime)s %(name)-12s %(levelname)-8s %(message)s')
	logfile_handler.formatter = logfile_formatter
	logger.addHandler(logfile_handler)
	return logger

def execute_and_log(command_string=[]):
	output = getoutput(command_string)
	logger.debug(command_string + ' ---> ' + output)
	return output
	
logger = get_logger()
