#!/usr/bin/env python
#--------------------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2008
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program License Agreement.
# See the software licensing materials that came with the IBM XIV Storage System for terms and conditions.
#
#--------------------------------------------------------------------------------------------------------------


from host_attach import logger
from platform import system, dist
from sys import exit
from host_attach import logger, is_error_free, execute_and_log, PACKAGE_DIR
import emulex_8_0_16_40, emulex_8_2_0_29


if (dist().__contains__('redhat') or dist().__contains__('centos')) and (dist().__contains__('4.6') or dist().__contains__('4.7')):
	from emulex_8_0_16_40 import emulex_install, emulex_verify, emulex_uninstall, emulex_scan, emulex_upgrade, is_emulex_driver_installed, is_emulex_driver_loaded, is_emulex_driver_up2date
else:
	from emulex_8_2_0_29 import emulex_install, emulex_verify, emulex_uninstall, emulex_scan, emulex_upgrade, is_emulex_driver_installed,  is_emulex_driver_loaded, is_emulex_driver_up2date

def emulex_get_scsi_hosts():
	hosts = []
	output = execute_and_log('find /sys/class/scsi_host/ -type f | grep lpfc_drvr_version')
	for node in output.split('/'):
		if node.__contains__('host') and not node.__contains__('scsi_host'):
			hosts.append(node)
	return hosts

def emulex_get_driver_string():
	return execute_and_log('cat /sys/class/scsi/scsi_host/' + host[0] + '/lpfc_drvr_version')

def emulex_get_driver_version_from_driver_string(string=''):
	elements = string.split()
	count = 0
	for element in elements:
		count = count +1
	return elements[count-1]

def emulex_get_driver_version():
	hosts = emulex_get_scsi_hosts()
	driver_string = emulex_get_driver_string()
	driver_version = emulex_get_driver_version_from_driver_string(driver_string)
	return driver_version

def emulex_wwn_print():
	logger.info('WWN for existing devices:')
	hosts = emulex_get_scsi_hosts()
	for host in hosts:
		output = execute_and_log('cat /sys/class/scsi_host/' + host + '/device/fc_host\:' + host + '/port_name')
		if not is_error_free(output):
			output = execute_and_log('cat /sys/class/scsi_host/' + host + '/port_name')
		logger.debug(output)
		print output
	return 1

